screen cg_gallery tag menu:
    add "black"
    #$ initGallery()

    $ start = gallery_page * maxperpage
    $ end = min(start + maxperpage - 1, len(gallery_items) - 1)
    $ lastPage = len(gallery_items)//maxperpage

    $ v_images_unlocked = 0
    $ v_images_locked = 0
    for i in range(0,  len(gallery_items)):
        $ gallery_items[i].refresh_lock()
        $ v_images_unlocked = v_images_unlocked +1


    text "Page: [gallery_page]/" +str(lastPage) xalign 0.5 yalign 0.03
    text "Unlocked: [v_images_unlocked] / "+str(len(gallery_items)) xalign 0.95 yalign 0.03



    grid maxnumx maxnumy:
        xfill True
        yfill True



        for i in range(start, end + 1):
                imagebutton idle gallery_items[i].thumb:
                    action Show("gallery_closeup", dissolve, gallery_items[i].images)
                    xalign 0.5
                    yalign 0.5


        for i in range(end - start + 1, maxperpage):
            null


    grid maxnumx maxnumy:
        xfill True
        yfill True

        for i in range(start, end + 1):
            hbox:
                spacing maxthumbx - 70
                xalign 0.5
                yalign 0.25

                $ total = gallery_items[i].num_images()
                $ partial = gallery_items[i].num_unlocked
                text gallery_items[i].name


        for i in range(end - start + 1, maxperpage):
            null



    if gallery_page > 0:
        textbutton "Previous":
            action SetVariable("gallery_page", gallery_page - 1)
            xalign 0.3
            yalign 0.98
            xpadding 25
            ypadding 10
        textbutton "First":
            action SetVariable("gallery_page", 0)
            xalign 0.1
            yalign 0.98
            xpadding 25
            ypadding 10
    if (gallery_page + 1) * maxperpage < len(gallery_items):
        textbutton "Next":
            action SetVariable("gallery_page", gallery_page + 1)
            xalign 0.7
            yalign 0.98
            xpadding 25
            ypadding 10
        textbutton "Last":
            action SetVariable("gallery_page", lastPage)
            xalign 0.9
            yalign 0.98
            xpadding 25
            ypadding 10

    textbutton "Return":
        action Return()
        xalign 0.5
        yalign 0.98
        xpadding 25
        ypadding 10

screen gallery_closeup(images):

    add images[closeup_page] at truecenter

    if closeup_page > 0:
        textbutton "Previous":
            action SetVariable("closeup_page", closeup_page - 1)
            xalign 0.1
            yalign 0.98
            xpadding 25
            ypadding 10
    if closeup_page < len(images) - 1:
        textbutton "Next":
            action SetVariable("closeup_page", closeup_page + 1)
            xalign 0.9
            yalign 0.98
            xpadding 25
            ypadding 10

    textbutton "Return":
        action [SetVariable("closeup_page", 0), Hide("gallery_closeup", dissolve)]
        xalign 0.05
        yalign 0.05
        xpadding 25
        ypadding 10

define all_gallery_enabled = False
init python:

    def createGalleryArray(id,name,subfolder,fileprefix,filesuffix,filelist):
        res=[]
        res.append(id)
        res.append(name)
        for i in range(0,  len(filelist)):
            tempfilename=str(filelist[i])
            if (tempfilename.startswith('#')):
                temp_file_mame=tempfilename
                temp_file_mame=temp_file_mame[1:]
                res.append(subfolder+temp_file_mame+filesuffix)
            else:
                res.append(subfolder+fileprefix+tempfilename+filesuffix)

        return res;

    def MaxScale(img, minwidth=config.screen_width, minheight=config.screen_height):
        currwidth, currheight = renpy.image_size(img)
        xscale = float(minwidth) / currwidth
        yscale = float(minheight) / currheight

        if xscale > yscale:
            maxscale = xscale
        else:
            maxscale = yscale

        return im.FactorScale(img, maxscale, maxscale)

    def MinScale(img, maxwidth=config.screen_width, maxheight=config.screen_height):
        currwidth, currheight = renpy.image_size(img)
        xscale = float(maxwidth) / currwidth
        yscale = float(maxheight) / currheight

        if xscale < yscale:
            minscale = xscale
        else:
            minscale = yscale

        return im.FactorScale(img, minscale, minscale)

    def ImgScale(img):
        return im.Scale(img, config.thumbnail_width, config.thumbnail_height)

    maxnumx = 4
    maxnumy = 2
    maxthumbx = (config.screen_width / (maxnumx + 1))/1
    maxthumby = ((config.screen_height) / (maxnumy + 1))/1
    maxperpage = maxnumx * maxnumy
    gallery_page = 0
    closeup_page = 0


    class GalleryItem:
        def __init__(self, name, images, thumb, locked="lockedthumb"):
            self.name = name
            self.images = images
            self.thumb = thumb
            self.locked = locked
            self.refresh_lock()

        def num_images(self):
            return len(self.images)

        def refresh_lock(self):
            self.num_unlocked = 0
            lockme = True
            if self.checkScene(self.name):
                lockme = False
            self.is_locked = lockme

        def checkScene(self, indexName=''):
            try:
                persistent.scene[indexName]
            except KeyError:
                return False
            return persistent.scene[indexName]

    class GalleryItemByID:
        def __init__(self, id, name, images, thumb, locked="lockedthumb"):
            self.id = id
            self.name = name
            self.images = images
            self.thumb = thumb
            self.locked = locked
            self.refresh_lock()

        def num_images(self):
            return len(self.images)

        def refresh_lock(self):
            self.num_unlocked = 0
            lockme = True
            if self.checkScene(self.id):
                lockme = False
            self.is_locked = lockme

        def checkScene(self, indexName=''):
            if all_gallery_enabled :
                return True
            try:
                persistent.scene[indexName]
            except KeyError:
                return False
            return persistent.scene[indexName]
